IBM Support

PI74527: Error CWWKZ0404E can occur when starting an application on Liberty

Fixes are available

17.0.0.1: WebSphere Application Server Liberty 17.0.0.1
17.0.0.2: WebSphere Application Server Liberty 17.0.0.2
17.0.0.3: WebSphere Application Server Liberty 17.0.0.3
17.0.0.4: WebSphere Application Server Liberty 17.0.0.4
18.0.0.1: WebSphere Application Server Liberty 18.0.0.1
18.0.0.2: WebSphere Application Server Liberty 18.0.0.2
18.0.0.3: WebSphere Application Server Liberty 18.0.0.3
18.0.0.4: WebSphere Application Server Liberty 18.0.0.4
19.0.0.1: WebSphere Application Server Liberty 19.0.0.1
19.0.0.2: WebSphere Application Server Liberty 19.0.0.2
19.0.0.3: WebSphere Application Server Liberty 19.0.0.3
19.0.0.4: WebSphere Application Server Liberty 19.0.0.4
19.0.0.5: WebSphere Application Server Liberty 19.0.0.5
19.0.0.6: WebSphere Application Server Liberty 19.0.0.6
19.0.0.7: WebSphere Application Server Liberty 19.0.0.7
19.0.0.8: WebSphere Application Server Liberty 19.0.0.8
19.0.0.9: WebSphere Application Server Liberty 19.0.0.9
19.0.0.10: WebSphere Application Server Liberty 19.0.0.10
19.0.0.11: WebSphere Application Server Liberty 19.0.0.11
19.0.0.12: WebSphere Application Server Liberty 19.0.0.12
20.0.0.1: WebSphere Application Server Liberty 20.0.0.1
20.0.0.2: WebSphere Application Server Liberty 20.0.0.2
20.0.0.3: WebSphere Application Server Liberty 20.0.0.3
20.0.0.4: WebSphere Application Server Liberty 20.0.0.4
20.0.0.5: WebSphere Application Server Liberty 20.0.0.5
20.0.0.6: WebSphere Application Server Liberty 20.0.0.6
20.0.0.7: WebSphere Application Server Liberty 20.0.0.7
20.0.0.8: WebSphere Application Server Liberty 20.0.0.8
20.0.0.9: WebSphere Application Server Liberty 20.0.0.9
20.0.0.10: WebSphere Application Server Liberty 20.0.0.10
20.0.0.11: WebSphere Application Server Liberty 20.0.0.11
20.0.0.12: WebSphere Application Server Liberty 20.0.0.12

Subscribe

You can track all active APARs for this component.

 

APAR status

  • Closed as program error.

Error description

  • The following error can sometimes be encountered when
    starting a
    application on Liberty.
    
    CWWKZ0404E: An exception was generated when trying to
    resolve
    the contents of the application.  The exception text from
    the OSGi framework is: Uses constraint violation. Unable to
    resolve resource com.ibm.ws.config [osgi.identity;
    osgi.identity="com.ibm.ws.config"; type="osgi.bundle";
    because it is exposed to package 'com.ibm.websphere.ras'
    from
    resources
    
    org.eclipse.osgi [osgi.identity;osgi.
    identity="org.eclipse.osgi"; type="osgi.bundle";
    
    and
    
    org.eclipse.osgi
    [osgi.identity; osgi.identity="org.eclipse.osgi";
    type="osgi.bundle"
    
    via two dependency chains.
    
    Chain 1:
    import:
    osgi.wiring.package=com.ibm.websphere.ras
    export: osgi.wiring.package: com.ibm.websphere.ras
    
    
    
    Chain 2:
    import: (osgi.wiring.package=com.ibm.websphere.ras)
    |
    export: osgi.wiring.package: com.ibm.websphere.ras
    

Local fix

Problem summary

  • ****************************************************************
    * USERS AFFECTED:  All users of IBM WebSphere Application      *
    *                  Server Liberty                              *
    ****************************************************************
    * PROBLEM DESCRIPTION: Error CWWKZ0404E can occur when install *
    *                      an OSGi Application with message        *
    *                      containing the phrase "Uses constraint  *
    *                      violation"                              *
    ****************************************************************
    * RECOMMENDATION:                                              *
    ****************************************************************
    A uses constraint violation in OSGi indicates that the bundles
    within the application could not be resolved to a consistent
    class space when there are multiple versions of the same package
    available to the application.  There is a bug in the OSGi
    resolver that incorrectly detects a uses constraint violation
    when there is none.  This results in a message like the
    following:
    
    Uses constraint violation. Unable to resolve resource
    com.ibm.ws.config [osgi.identity;
    osgi.identity="com.ibm.ws.config"; type="osgi.bundle"; because
    it is exposed to package 'com.ibm.websphere.ras' from resources
    
    org.eclipse.osgi
    [osgi.identity;osgi.identity="org.eclipse.osgi";
    type="osgi.bundle";
    
    and
    
    org.eclipse.osgi[osgi.identity;
    osgi.identity="org.eclipse.osgi"; type="osgi.bundle";
    
    This is incorrect.  There is no uses constraint violation here
    because the two resources in the error message are the same
    resource.
    

Problem conclusion

  • The OSGi Resolver bug was fixed to correctly handle fragments
    that have more than one host where the host and the fragment
    import the same package.
    
    The fix for this APAR is currently targeted for inclusion in fix
    pack 17.0.0.1.  Please refer to the Recommended Updates page for
    delivery information:
    http://www.ibm.com/support/docview.wss?rs=180&uid=swg27004980
    

Temporary fix

Comments

APAR Information

  • APAR number

    PI74527

  • Reported component name

    WAS LIBERTY COR

  • Reported component ID

    5725L2900

  • Reported release

    855

  • Status

    CLOSED PER

  • PE

    NoPE

  • HIPER

    NoHIPER

  • Special Attention

    NoSpecatt / Xsystem

  • Submitted date

    2017-01-06

  • Closed date

    2017-02-16

  • Last modified date

    2017-02-16

  • APAR is sysrouted FROM one or more of the following:

  • APAR is sysrouted TO one or more of the following:

Fix information

  • Fixed component name

    WAS LIBERTY COR

  • Fixed component ID

    5725L2900

Applicable component levels

  • R855 PSY

       UP

[{"Business Unit":{"code":"BU053","label":"Cloud \u0026 Data Platform"},"Product":{"code":"SSD28V","label":"WebSphere Application Server Liberty Core"},"Platform":[{"code":"PF025","label":"Platform Independent"}],"Version":"855","Line of Business":{"code":"LOB36","label":"IBM Automation"}}]

Document Information

Modified date:
18 October 2021